/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation (Xerox). 
 * Portions created by Xerox are Copyright (C) 1999-2001 Xerox Corporation.
 * Portions created by Palo Alto Research Center, Incorporated are 
 * Copyright (C) 1999-2002 Palo Alto Research Center, Incorporated.
 * All Rights Reserved.
 *
 * Contributor(s):
 */
 
package org.aspectj.tools.ajde.netbeans;

import java.awt.event.ActionEvent;

import javax.swing.*;

import org.aspectj.ajde.ui.swing.BuildConfigPopupMenu;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
//XXX failing under javac??: import org.openide.awt.ToolbarButton;

/** 
 * @author  Mik Kersten
 */
public class AJSelectConfigurationAction extends CallableSystemAction {
    
    public static boolean PROP_ENABLED = false;
    private JPopupMenu orderMenu = null;
    
    public void performAction() { }       
       
    public void actionPerformed(ActionEvent e) {
       
		orderMenu = new BuildConfigPopupMenu(BUILD_ACTION);
        JButton button = (JButton) (e.getSource());
        int x = (int) button.getLocationOnScreen().getX();
        int y = (int) button.getLocationOnScreen().getY() + 25;
        orderMenu.setLocation(x, y);

		orderMenu.setVisible(true);
		orderMenu.repaint();
    }

	final AbstractAction BUILD_ACTION = new AbstractAction() {
		public void actionPerformed(ActionEvent arg0) {
	        NbManager.INSTANCE.saveAll();
	        orderMenu.setVisible(false);
		};
	};
    
    public String getName() {
        return NbBundle.getMessage(AJSelectConfigurationAction.class, 
        	"LBL_AJSelectConfigurationAction");
    }
    
    protected String iconResource() {
        return "/org/aspectj/ajde/resources/actions/popup.gif";
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    public void setEnabled(boolean enable){
        PROP_ENABLED = enable;
        super.setEnabled(enable);
    }
    
    public boolean isEnabled(){
        return PROP_ENABLED;
    }
        
    /** Perform extra initialization of this action's singleton. 
     * PLEASE do not use constructors for this purpose! */
    protected void initialize () {
        super.initialize();
    	super.setEnabled(false);
    }
}
